;***************
;**  PAG 166  **
;***************




TITLE   X08.ASM (COM)
        .MODEL small
        .CODE
        ORG     100H
BEGIN:  JMP     SHORT PRINCIPIO
CONTER  DB      00         	;contador de caracteres ASCII
COL     DB      24         	;columna de la pantalla
ROW     DB      04         	;reglon de la pantalla
MODO    DB      ?          	;modo de video

;	Procedimiento principal
;===============================================================================:
PRINCIPIO PROC    NEAR
        CALL    XMODO    	;obtiene/designa el modo e video
        CALL    PLIMPIA     	;limpia la pantalla
LAZO1:
        CALL    CURFIJA     	;COLoca el cursor
        CALL    DISPLAY    	;despliega el caracteres
        CMP     CONTER,0ffh	;Es el ultimo caracter desplegado?
        JE      LAZO2 		;  si, entonces salir
        INC     CONTER		;Incrementar el contador ASCII
        ADD     COL,02		;Incrementar la columna
        CMP     COL,56		;Se llego a la ultima columna?
        JNE     LAZO1		;  no, entonces saltar
        INC     ROW		;  si, incrementar una fila
        MOV     COL,24		;  y reiciciar la columna
        JMP     LAZO1
LAZO2:
        CALL    TLEER		;Obtener caracter del teclado
        CALL    YMODO		;Restaurar el modo del video
        MOV     AX,4c00h	;Salir al DOS
        int     21h
PRINCIPIO    ENDP

;	Obtener y designar el modo del video
;===============================================================================:
XMODO PROC 	NEAR
        MOV     AH,0FH		;Peticion para obtener el modo
        INT     10H
        MOV     MODO,AL		;Guardar el modo
        MOV     AH,00H		;Peticion para establecer un nuevo modo
        MOV     AL,03
        RET
XMODO ENDP


;	Limpia pantalla y crea una ventana
;===============================================================================:
PLIMPIA  PROC    NEAR
        MOV     AH,08H		;Peticion para obtener el atributo
        INT     10H		;  actual en AH
        MOV     BH,AH		;Lo mueve a BH
        MOV     AX,0600H	;Recorre toda la pantalla
        MOV     CX,0000		;posicion superior de la izquierda
        MOV     DX,184fH	;Posicion inferior de la derecha
        INT     10H
        MOV     AX,0610H	;Crea una ventana de 16 lineas
        MOV     BH,16H		;Cafe sobre azul
        MOV     cx,0418H	;Esquina superior izquierda en 04:24
        MOV     DX,1336H	;Esquina inferior derecha en 19:54
        INT     10H
        RET
PLIMPIA  ENDP

;	Coloca el cursor sobre la fila y la columna
;===============================================================================:
CURFIJA  PROC    NEAR
        MOV     AH,02H		;Peticion para colocar el cursor
        MOV     BH,00		;Pagina 0(normal)
        MOV     DH,ROW		;Nueva fila
        MOV     DL,COL		;Nueva columna
        INT     10H
        RET
CURFIJA  ENDP

;	Despliega caracteres ASCII
;===============================================================================:
DISPLAY PROC    NEAR
        MOV     AH,0AH 		;Despliega
        MOV     AL,CONTER		;Caracter ASCII
        MOV     BH,00		;Pagina 0
        MOV     CX,01		;Un caracter
        INT     10h
        RET
DISPLAY ENDP

;	Obliga a detenerse, obtiene un caracter del teclado
;===============================================================================:
TLEER 	PROC    NEAR
        MOV     AH,10H		;Peticion para obtener caracter
        INT     16h
        RET
TLEER 	ENDP

;	Restaura el modo de video original
;===============================================================================:
YMODO PROC    NEAR
        MOV     AH,00H		;Peticion para establacer el modo
        MOV     AL,MODO		;Valor original
        INT     10H
        RET
YMODO ENDP
END     BEGIN
